#include <sys/time.h>

#include <ostream>

#include "timer.h"


namespace timer {

Timer::Timer()
  : start_time_(gettime())
{
}

Timer::~Timer()
{
}

void Timer::restart()
{
  start_time_ = gettime();
}

double Timer::elapsed() const
{
  return gettime() - start_time_;
}

double Timer::gettime() const
{
  struct timeval tv;
  gettimeofday(&tv, NULL);
  return tv.tv_sec + tv.tv_usec * 1e-6;
}

std::ostream& operator<<(std::ostream& os, Timer& t)
{
  os << t.elapsed();
  return os;
}

} // namespace timer
